## hvml-purc 0.8.1

=== CMakeLists.txt ===
# -----------------------------------------------------------------------------
# Determine CMake version and build type.
# -----------------------------------------------------------------------------
#
# NOTE: cmake_minimum_required() and project() *MUST* be the two first commands
# used, see https://cmake.org/cmake/help/v3.3/command/project.html -- the
# latter in particular handles loading a bunch of shared CMake definitions
# and loading the cross-compilation settings from CMAKE_TOOLCHAIN_FILE.
#

cmake_minimum_required(VERSION 3.15)

project(PurC C CXX)

if (NOT CMAKE_BUILD_TYPE)
    message(WARNING "No CMAKE_BUILD_TYPE value specified, defaulting to RelWithDebInfo.")
    set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose the type of build." FORCE)
else ()
    message(STATUS "The CMake build type is: ${CMAKE_BUILD_TYPE}")
endif ()

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/Source/cmake")

# -----------------------------------------------------------------------------
# Determine which port will be built
# -----------------------------------------------------------------------------
set(ALL_PORTS
    Linux
    Mac
    Windows
)
set(PORT "NOPORT" CACHE STRING "choose which PurC port to build (one of ${ALL_PORTS})")

list(FIND ALL_PORTS ${PORT} RET)
if (${RET} EQUAL -1)
    message(FATAL_ERROR "Please choose which PurC port to build (one of ${ALL_PORTS})")
endif ()

string(TOLOWER ${PORT} PURC_PORT_DIR)

# -----------------------------------------------------------------------------
# Determine the compiler
# -----------------------------------------------------------------------------
if (${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang" OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "AppleClang")
    set(COMPILER_IS_CLANG ON)
endif ()

if (${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
    if (${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS "7.3.0")
        message(FATAL_ERROR "GCC 7.3 or newer is required to build PurC. Use a newer GCC version or Clang.")
    endif ()
endif ()

if (CMAKE_COMPILER_IS_GNUCXX OR COMPILER_IS_CLANG)
    set(COMPILER_IS_GCC_OR_CLANG ON)
endif ()

if (MSVC AND COMPILER_IS_CLANG)
    set(COMPILER_IS_CLANG_CL ON)
endif ()

# -----------------------------------------------------------------------------
# Determine the target processor
# -----------------------------------------------------------------------------
# Use MSVC_CXX_ARCHITECTURE_ID instead of CMAKE_SYSTEM_PROCESSOR when defined,
# since the later one just resolves to the host processor on Windows.
if (MSVC_CXX_ARCHITECTURE_ID)
    string(TOLOWER ${MSVC_CXX_ARCHITECTURE_ID} LOWERCASE_CMAKE_SYSTEM_PROCESSOR)
else ()
    string(TOLOWER ${CMAKE_SYSTEM_PROCESSOR} LOWERCASE_CMAKE_SYSTEM_PROCESSOR)
endif ()
if (LOWERCASE_CMAKE_SYSTEM_PROCESSOR MATCHES "(^aarch64|^arm64)")
    set(WTF_CPU_ARM64 1)
elseif (LOWERCASE_CMAKE_SYSTEM_PROCESSOR MATCHES "^arm")
    set(WTF_CPU_ARM 1)
elseif (LOWERCASE_CMAKE_SYSTEM_PROCESSOR MATCHES "^mips64")
    set(WTF_CPU_MIPS64 1)
elseif (LOWERCASE_CMAKE_SYSTEM_PROCESSOR MATCHES "^mips")
    set(WTF_CPU_MIPS 1)
elseif (LOWERCASE_CMAKE_SYSTEM_PROCESSOR MATCHES "(x64|x86_64|amd64)")
    # FORCE_32BIT is set in the build script when --32-bit is passed
    # on a Linux/intel 64bit host. This allows us to produce 32bit
    # binaries without setting the build up as a crosscompilation,
    # which is the only way to modify CMAKE_SYSTEM_PROCESSOR.
    if (FORCE_32BIT)
        set(WTF_CPU_X86 1)
    else ()
        set(WTF_CPU_X86_64 1)
    endif ()
elseif (LOWERCASE_CMAKE_SYSTEM_PROCESSOR MATCHES "(i[3-6]86|x86)")
    set(WTF_CPU_X86 1)
elseif (LOWERCASE_CMAKE_SYSTEM_PROCESSOR MATCHES "ppc")
    set(WTF_CPU_PPC 1)
elseif (LOWERCASE_CMAKE_SYSTEM_PROCESSOR MATCHES "ppc64")
    set(WTF_CPU_PPC64 1)
elseif (LOWERCASE_CMAKE_SYSTEM_PROCESSOR MATCHES "ppc64le")
    set(WTF_CPU_PPC64LE 1)
else ()
    set(WTF_CPU_UNKNOWN 1)
endif ()

# -----------------------------------------------------------------------------
# Determine the operating system
# -----------------------------------------------------------------------------
if (UNIX)
    if (APPLE)
        set(WTF_OS_MAC_OS_X 1)
    elseif (CMAKE_SYSTEM_NAME MATCHES "Linux")
        set(WTF_OS_LINUX 1)
    else ()
        set(WTF_OS_UNIX 1)
    endif ()
elseif (CMAKE_SYSTEM_NAME MATCHES "Windows")
    set(WTF_OS_WINDOWS 1)
elseif (CMAKE_SYSTEM_NAME MATCHES "Fuchsia")
    set(WTF_OS_FUCHSIA 1)
else ()
    message(FATAL_ERROR "Unknown OS '${CMAKE_SYSTEM_NAME}'")
endif ()

# -----------------------------------------------------------------------------
# Default library types
# -----------------------------------------------------------------------------
# By default, only the highest-level libraries, PurC, is
# shared, because properly building shared libraries that depend on each other
# can be tricky. Override these in Options*.cmake for your port as needed.
set(bmalloc_LIBRARY_TYPE STATIC)
set(WTF_LIBRARY_TYPE STATIC)
set(PurC_LIBRARY_TYPE SHARED)

set(PURC_API_VERSION 0.8)

set(CMAKE_POSITION_INDEPENDENT_CODE True)

# -----------------------------------------------------------------------------
# Common configuration
#------------------------------------------------------------------------------
include(PurCCommon)

SET_PROJECT_VERSION(0 8 1)

add_subdirectory(Source)

# -----------------------------------------------------------------------------
# Print the features list last, for maximum visibility.
# -----------------------------------------------------------------------------
PRINT_PURC_OPTIONS()

# Packing stuff
set(CPACK_PACKAGE_VENDOR "FMSoft")
set(CPACK_PACKAGE_NAME ${PROJECT_NAME})
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "PurC: an HVML parser and interpreter in C/C++ lanuage")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_IGNORE_FILES
      "/auto/;/cmake/;/.svn/;/.git/;/.bzr/;/CMakeFiles/;/_CPack_Packages/;CMakeCache.txt$;
      ~$;.swp$;.cmake$;
      ${CPACK_SOURCE_IGNORE_FILES}")

#include(CPack)

=== Source/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# Add components directories
# -----------------------------------------------------------------------------
#if (NOT USE_SYSTEM_MALLOC)
#    add_subdirectory(bmalloc)
#endif ()

add_subdirectory(WTF)

add_subdirectory(PurC)

add_subdirectory(ExtDVObjs)

add_subdirectory(Samples)

add_subdirectory(Tools)

if (ENABLE_API_TESTS)
    add_subdirectory(ThirdParty/gtest)
    add_subdirectory(valgrind)
    add_subdirectory(test)
endif ()

PURC_INCLUDE_CONFIG_FILES_IF_EXISTS()

=== Source/ExtDVObjs/CMakeLists.txt ===
set_property(DIRECTORY . PROPERTY FOLDER "ExtDVObjs")

include(PurCCommon)

add_subdirectory(fs)
add_subdirectory(math)

=== Source/PurC/CMakeLists.txt ===
set_property(DIRECTORY . PROPERTY FOLDER "PurC")

include(PurCCommon)
include(MyMacros.cmake)

configure_file(include/purc-version.h.in ${PurC_DERIVED_SOURCES_DIR}/purc-version.h @ONLY)
configure_file(include/purc-features.h.in ${PurC_DERIVED_SOURCES_DIR}/purc-features.h @ONLY)

set(PurC_PRIVATE_INCLUDE_DIRECTORIES
    "${CMAKE_BINARY_DIR}"
    "${PURC_DIR}"
    "${PURC_DIR}/include"
    "${PurC_DERIVED_SOURCES_DIR}"
    "${FORWARDING_HEADERS_DIR}"
    "${CMAKE_BINARY_DIR}/Source/PurC"
)

# TODO: List the headers should be installed to system here.
set(PurC_INSTALLED_HEADERS
    "${PurC_DERIVED_SOURCES_DIR}/purc-version.h"
    "${PurC_DERIVED_SOURCES_DIR}/purc-features.h"
    "${PURC_DIR}/include/purc-macros.h"
    "${PURC_DIR}/include/purc-errors.h"
    "${PURC_DIR}/include/purc-variant.h"
    "${PURC_DIR}/include/purc-rwstream.h"
    "${PURC_DIR}/include/purc-utils.h"
    "${PURC_DIR}/include/purc-dom.h"
    "${PURC_DIR}/include/purc-html.h"
    "${PURC_DIR}/include/purc-ports.h"
    "${PURC_DIR}/include/purc-pcrdr.h"
    "${PURC_DIR}/include/purc-helpers.h"
    "${PURC_DIR}/include/purc-dvobjs.h"
    "${PURC_DIR}/include/purc-runloop.h"
    "${PURC_DIR}/include/purc-executor.h"
    "${PURC_DIR}/include/purc-document.h"
    "${PURC_DIR}/include/purc.h"
)

# TODO: List the directorires which do not contain any platform-dependent C source files
set(PurC_PLATFORM_INDEPENDENT_DIRS
    "instance"
    "utils"
    "variant"
    "html"
    "dom"
    "dvobjs"
    "dvobjs/parsers"
    "vcm"
    "ejson"
    "hvml"
    "vdom"
    "executors"
    "executors/parsers"
    "interpreter"
    "fetchers"
    "pcrdr"
    "document"
)

# This macro will append all C/CXX source files in ${PurC_PLATFORM_INDEPENDENT_DIRS}
# to ${PurC_SOURCES}
APPEND_ALL_SOURCE_FILES_IN_DIRLIST(PurC_SOURCES "${PurC_PLATFORM_INDEPENDENT_DIRS}")

# TODO: List the source files individually.
list(APPEND PurC_SOURCES
    "${PURC_DIR}/ports/vasprintf.c"
    "${PURC_DIR}/ports/misc.c"
)

# Put the CXX source files which can be unified in `Sources.txt`
list(APPEND PurC_UNIFIED_SOURCE_LIST_FILES
    "Sources.txt"
)

set(PurC_LIBRARIES)
set(PurC_DEPENDENCIES)

# TODO: the source files and libraries for optional features.
if (ENABLE_WEBSOCKET)
    list(APPEND PurC_UNIFIED_SOURCE_LIST_FILES
        "SourcesWebSocket.txt"
    )
    list(APPEND PurC_PRIVATE_INCLUDE_DIRECTORIES
    )
    list(APPEND PurC_SOURCES 
    )
endif ()

if (ENABLE_LSQL)
    list(APPEND PurC_LIBRARIES SQLite::SQLite3)
endif ()

if (ENABLE_XML)
    list(APPEND PurC_LIBRARIES LibXml2::LibXml2)
endif ()

set(PurC_INTERFACE_LIBRARIES PurC)
set(PurC_INTERFACE_INCLUDE_DIRECTORIES ${PurC_PRIVATE_FRAMEWORK_HEADERS_DIR})

PURC_FRAMEWORK_DECLARE(PurC)
PURC_INCLUDE_CONFIG_FILES_IF_EXISTS()

set(_parsers
        exe_key exe_range exe_filter
        exe_char exe_token
        exe_add exe_sub exe_mul exe_div exe_formula exe_objformula
        exe_sql exe_travel
        exe_func exe_class
        match_for
        ejson)
PURC_PARSERS_GEN_IN(executors/parsers "${_parsers}" "")
unset(_parsers)

set(_parsers logical)
PURC_PARSERS_GEN_IN(dvobjs/parsers "${_parsers}" "")
unset(_parsers)

# Generate constants for HTML ns/tags/interfaces
add_custom_command(
    OUTPUT "${PurC_DERIVED_SOURCES_DIR}/html_foo.c"
        ${PurC_DERIVED_SOURCES_DIR}/ns_const.h
        ${PurC_DERIVED_SOURCES_DIR}/ns_res.h
        ${PurC_DERIVED_SOURCES_DIR}/html_tag_const.h
        ${PurC_DERIVED_SOURCES_DIR}/html_tag_res.h
        ${PurC_DERIVED_SOURCES_DIR}/html_interface_res.h
        ${PurC_DERIVED_SOURCES_DIR}/html_tag_res_ext.h
    MAIN_DEPENDENCY ${PURC_DIR}/html/tags.py
    DEPENDS ${PURC_DIR}/html/interfaces.py
            ${PURC_DIR}/html/ns_const.h.in
            ${PURC_DIR}/html/ns_res.h.in
            ${PURC_DIR}/html/html_interface_res.h.in
            ${PURC_DIR}/html/html_tag_res_ext.h.in
            ${PURC_DIR}/html/html_tag_const.h.in
            ${PURC_DIR}/html/html_tag_res.h.in
    COMMAND ${Python3_EXECUTABLE} ${PURC_DIR}/html/tags.py "${PurC_DERIVED_SOURCES_DIR}" --without-print
    COMMAND touch "${PurC_DERIVED_SOURCES_DIR}/html_foo.c"
    COMMENT "Generating files for HTML tags and interfaces by using ${Python3_EXECUTABLE}"
    WORKING_DIRECTORY "${PURC_DIR}/html/"
    VERBATIM)
list(APPEND PurC_SOURCES ${PurC_DERIVED_SOURCES_DIR}/html_foo.c)

# Generate constants for HTML attributes
add_custom_command(
    OUTPUT "${PurC_DERIVED_SOURCES_DIR}/html_attr_foo.c" "${PurC_DERIVED_SOURCES_DIR}/html_attr_res.h" "${PurC_DERIVED_SOURCES_DIR}/html_attr_const.h"
    MAIN_DEPENDENCY ${PURC_DIR}/html/attr.py
    DEPENDS ${PURC_DIR}/html/attr_res.h.in ${PURC_DIR}/html/attr_const.h.in
    COMMAND ${Python3_EXECUTABLE} ${PURC_DIR}/html/attr.py "${PurC_DERIVED_SOURCES_DIR}" --without-print
    COMMAND touch "${PurC_DERIVED_SOURCES_DIR}/html_attr_foo.c"
    COMMENT "Generating html_attr_res.h and html_attr_const.h by using ${Python3_EXECUTABLE}"
    WORKING_DIRECTORY "${PURC_DIR}/html/"
    VERBATIM)
list(APPEND PurC_SOURCES ${PurC_DERIVED_SOURCES_DIR}/html_attr_foo.c)

# Copy str_res.h.in to DerivedSources
add_custom_command(
    OUTPUT "${PurC_DERIVED_SOURCES_DIR}/html_bar.c" "${PurC_DERIVED_SOURCES_DIR}/str_res.h"
    COMMAND ${CMAKE_COMMAND} -E copy "${PURC_DIR}/html/str_res.h.in"
        "${PurC_DERIVED_SOURCES_DIR}/str_res.h"
    COMMAND touch "${PurC_DERIVED_SOURCES_DIR}/html_bar.c"
    DEPENDS "${PURC_DIR}/html/str_res.h.in"
    COMMENT "Copying str_res.h.in to DerivedSources"
    VERBATIM)
list(APPEND PurC_SOURCES ${PurC_DERIVED_SOURCES_DIR}/html_bar.c)

# Generate keywords table for hvml language
set(_kw_h           "${PurC_DERIVED_SOURCES_DIR}/keywords.h")
set(_kw_inc         "${PurC_DERIVED_SOURCES_DIR}/keywords.inc")
set(_kw_foo         "${PurC_DERIVED_SOURCES_DIR}/keywords-foo.c")
set(_kw_py          "${PURC_DIR}/instance/make-keywords-table.py")
set(_kw_txt         "${PURC_DIR}/instance/data/keywords.txt")
set(_kw_h_in        "${PURC_DIR}/instance/data/keywords.h.in")
set(_kw_inc_in      "${PURC_DIR}/instance/data/keywords.inc.in")
add_custom_command(
    OUTPUT "${_kw_foo}"
           "${_kw_h}"
           "${_kw_inc}"
    MAIN_DEPENDENCY "${_kw_py}"
    DEPENDS "${_kw_txt}"
            "${_kw_h_in}"
            "${_kw_inc_in}"
    COMMAND "${Python3_EXECUTABLE}" "${_kw_py}"
            "--dest" "${PurC_DERIVED_SOURCES_DIR}"
            "--kw_h"        "${_kw_h}"
            "--kw_inc"      "${_kw_inc}"
            "--kw_foo"      "${_kw_foo}"
            "--kw_txt"      "${_kw_txt}"
            "--kw_h_in"     "${_kw_h_in}"
            "--kw_inc_in"   "${_kw_inc_in}"
            "--without-print"
    COMMAND touch "${_kw_foo}"
    COMMENT "Generating keywords.h/keywords.inc by using ${Python3_EXECUTABLE}"
    WORKING_DIRECTORY "${PURC_DIR}/instance/"
    VERBATIM)
list(APPEND PurC_SOURCES ${_kw_foo})
unset(_kw_h)
unset(_kw_inc)
unset(_kw_foo)
unset(_kw_py)
unset(_kw_txt)
unset(_kw_h_in)
unset(_kw_inc_in)

# Generate attrs table for hvml parser
add_custom_command(
    OUTPUT "${PurC_DERIVED_SOURCES_DIR}/hvml-attr-foo.c"
           "${PurC_DERIVED_SOURCES_DIR}/hvml-attr-static-list.inc"
    MAIN_DEPENDENCY ${PURC_DIR}/hvml/make-attrs-table.py
    DEPENDS "${PURC_DIR}/hvml/data/attrs.txt"
            "${PURC_DIR}/hvml/data/attr-static-list.inc.in"
    COMMAND ${Python3_EXECUTABLE} ${PURC_DIR}/hvml/make-attrs-table.py "${PurC_DERIVED_SOURCES_DIR}" --without-print
    COMMAND touch "${PurC_DERIVED_SOURCES_DIR}/hvml-attr-foo.c"
    COMMENT "Generating hvml-attr-static-list.inc by using ${Python3_EXECUTABLE}"
    WORKING_DIRECTORY "${PURC_DIR}/hvml/"
    VERBATIM)
list(APPEND PurC_SOURCES ${PurC_DERIVED_SOURCES_DIR}/hvml-attr-foo.c)

# Generate tags table for hvml parser
add_custom_command(
    OUTPUT "${PurC_DERIVED_SOURCES_DIR}/hvml-tag-foo.c"
           "${PurC_DERIVED_SOURCES_DIR}/hvml-tag-static-list.inc"
           "${PurC_DERIVED_SOURCES_DIR}/hvml-tag.h"
    MAIN_DEPENDENCY ${PURC_DIR}/hvml/make-tags-table.py
    DEPENDS "${PURC_DIR}/hvml/data/tags.txt"
            "${PURC_DIR}/hvml/data/tag-static-list.inc.in"
            "${PURC_DIR}/hvml/data/tag.h.in"
    COMMAND ${Python3_EXECUTABLE} ${PURC_DIR}/hvml/make-tags-table.py "${PurC_DERIVED_SOURCES_DIR}" --without-print
    COMMAND touch "${PurC_DERIVED_SOURCES_DIR}/hvml-tag-foo.c"
    COMMENT "Generating hvml-tag-static-list.inc/hvml-tag.h by using ${Python3_EXECUTABLE}"
    WORKING_DIRECTORY "${PURC_DIR}/hvml/"
    VERBATIM)
list(APPEND PurC_SOURCES ${PurC_DERIVED_SOURCES_DIR}/hvml-tag-foo.c)

add_custom_command(
    OUTPUT "${PurC_DERIVED_SOURCES_DIR}/purc-error-except.c"
           "${PurC_DERIVED_SOURCES_DIR}/generic_err_msgs.inc"
           "${PurC_DERIVED_SOURCES_DIR}/executor_err_msgs.inc"
           "${PurC_DERIVED_SOURCES_DIR}/variant_err_msgs.inc"
           "${PurC_DERIVED_SOURCES_DIR}/ejson_err_msgs.inc"
           "${PurC_DERIVED_SOURCES_DIR}/rwstream_err_msgs.inc"
           "${PurC_DERIVED_SOURCES_DIR}/hvml_err_msgs.inc"
           "${PurC_DERIVED_SOURCES_DIR}/pcrdr_err_msgs.inc"
    MAIN_DEPENDENCY ${BUILD_TOOLS_DIR}/make-error-info.py
    DEPENDS "${PURC_DIR}/instance/generic.error.in"
            ${PURC_DIR}/executors/executor.error.in
            ${PURC_DIR}/variant/variant.error.in
            ${PURC_DIR}/ejson/ejson.error.in
            ${PURC_DIR}/utils/rwstream.error.in
            ${PURC_DIR}/hvml/hvml.error.in
            ${PURC_DIR}/pcrdr/pcrdr.error.in
    COMMAND ${Python3_EXECUTABLE} ${BUILD_TOOLS_DIR}/make-error-info.py "${PurC_DERIVED_SOURCES_DIR}"
            ${PURC_DIR}/instance/generic.error.in
            ${PURC_DIR}/executors/executor.error.in
            ${PURC_DIR}/variant/variant.error.in
            ${PURC_DIR}/ejson/ejson.error.in
            ${PURC_DIR}/utils/rwstream.error.in
            ${PURC_DIR}/hvml/hvml.error.in
            ${PURC_DIR}/pcrdr/pcrdr.error.in
    COMMAND touch "${PurC_DERIVED_SOURCES_DIR}/purc-error-except.c"
    COMMENT "Generating *_err_msgs.inc by using ${Python3_EXECUTABLE}"
    WORKING_DIRECTORY "${PURC_DIR}/instance/"
    VERBATIM)
list(APPEND PurC_SOURCES ${PurC_DERIVED_SOURCES_DIR}/purc-error-except.c)


PURC_WRAP_SOURCELIST(${PurC_SOURCES})

PURC_COPY_FILES(PurC_CopyPrivateHeaders
    DESTINATION ${PurC_PRIVATE_FRAMEWORK_HEADERS_DIR}/PurC
    FILES ${PurC_PRIVATE_FRAMEWORK_HEADERS}
    FLATTENED
)
list(APPEND PurC_INTERFACE_DEPENDENCIES PurC_CopyPrivateHeaders)
# PurC_CopyPrivateHeaders needs to have a direct or indirect
# dependency of PurC target for CMake Visual Studio generator to
# eliminate duplicated custom commands. Otherwise, CSSPropertyNames.h
# will be generated in both projects.
if (NOT INTERNAL_BUILD)
    add_dependencies(PurC_CopyPrivateHeaders PurC)
    add_dependencies(PurC WTF)
endif ()


PURC_COMPUTE_SOURCES(PurC)
PURC_FRAMEWORK(PurC)
PURC_FRAMEWORK_TARGET(PurC)

# The -ftree-sra optimization (implicit with -O2) causes crashes when
# allocating large chunks of memory using bmalloc on Intel 32bit.
# See https://bugs.webkit.org/show_bug.cgi?id=146440
string(TOLOWER ${CMAKE_HOST_SYSTEM_PROCESSOR} LOWERCASE_CMAKE_HOST_SYSTEM_PROCESSOR)
if (CMAKE_COMPILER_IS_GNUCXX AND "${LOWERCASE_CMAKE_HOST_SYSTEM_PROCESSOR}" MATCHES "(i[3-6]86|x86)$")
    PURC_ADD_TARGET_CXX_FLAGS(PurC -fno-tree-sra)
endif ()

if (${PurC_LIBRARY_TYPE} MATCHES "SHARED")
    set_target_properties(PurC PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
    install(TARGETS PurC DESTINATION "${LIB_INSTALL_DIR}")
endif ()

if (MSVC)
    set_target_properties(PurC PROPERTIES
        COMPILE_PDB_NAME ${PurC_OUTPUT_NAME}
    )
endif ()

# add_subdirectory(res)

install(TARGETS PurC
        DESTINATION "${LIB_INSTALL_DIR}/"
)

install(FILES ${PurC_INSTALLED_HEADERS}
        DESTINATION "${HEADER_INSTALL_DIR}/purc"
)

=== Source/Samples/CMakeLists.txt ===
add_subdirectory(api)
#add_subdirectory(fetcher)

PURC_COPY_FILES(ScriptToRunSamples
    DESTINATION ${CMAKE_BINARY_DIR}/
    FILES run_all_samples.sh
)

set(sample_HVML_FILES
    "hvml/hello.hvml"
    "hvml/您好.hvml"
    "hvml/hello-10.hvml"
    "hvml/hello-html.hvml"
    "hvml/hello-html-timer.hvml"
    "hvml/hello-world-0.hvml"
    "hvml/hello-world-1.hvml"
    "hvml/hello-world-2.hvml"
    "hvml/hello-world-3.hvml"
    "hvml/hello-world-4.hvml"
    "hvml/hello-world-5.hvml"
    "hvml/hello-world-6.hvml"
    "hvml/hello-world-7.hvml"
    "hvml/hello-world-8.hvml"
    "hvml/hello-world-9.hvml"
    "hvml/hello-world-a.hvml"
    "hvml/hello-world-b.hvml"
    "hvml/hello-world-c.hvml"
    "hvml/hello-world.json"
    "hvml/fibonacci-void-temp.hvml"
    "hvml/fibonacci-html-temp.hvml"
    "hvml/fibonacci-html-temp-rdr.hvml"
    "hvml/calculator-bc.hvml"
    "hvml/planetary-resonance-lines.hvml"
    "hvml/planetary-resonance.hvml"
    "hvml/greatest-common-divisor.hvml"
    "hvml/execute-in-place-void.hvml"
    "hvml/execute-in-place-html.hvml"
    "hvml/load-string-hvml.hvml"
    "hvml/load-another-body.hvml"
    "hvml/call-concurrently.hvml"
)

PURC_COPY_FILES(SampleHVMLFiles
    DESTINATION "${CMAKE_BINARY_DIR}"
    FILES ${sample_HVML_FILES}
)

=== Source/Tools/CMakeLists.txt ===
if (HAVE_GLIB AND HAVE_NCURSES)
#    add_subdirectory(udom-editor)
endif ()

add_subdirectory(purc)

=== Source/WTF/CMakeLists.txt ===
set_property(DIRECTORY . PROPERTY FOLDER "WTF")

include(PurCCommon)
include(MyMacros.cmake)

CHECK_THREAD_LOCAL_STORAGE_KEYWORD()
configure_file(wtf/TLSKeyword.h.in ${WTF_FRAMEWORK_HEADERS_DIR}/wtf/TLSKeyword.h)

add_subdirectory(wtf)

=== Source/test/CMakeLists.txt ===
add_subdirectory(utils)
add_subdirectory(rwstream)
add_subdirectory(variant)
add_subdirectory(instance)
add_subdirectory(misc)
add_subdirectory(tree)
add_subdirectory(ejson)
add_subdirectory(html)
add_subdirectory(dvobjs)
add_subdirectory(extdvobjs)
add_subdirectory(hvml)
add_subdirectory(vcm)
add_subdirectory(vdom)
add_subdirectory(executors)
add_subdirectory(interpreter)
add_subdirectory(fetcher)
add_subdirectory(wtf)
add_subdirectory(externals)

PURC_COPY_FILES(TEST_Script
    DESTINATION ${CMAKE_BINARY_DIR}/
    FILES run_all_tests.sh
)

=== Source/valgrind/CMakeLists.txt ===
PURC_COPY_FILES(VALGRIND_Suppressions
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/
    FILES valgrind.supp
)

=== deprecated/examples/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.0)

PROJECT(purring-cat-2-examples C)

SET(PROJECT_NAME "purring-cat-2-examples")
SET(PROJECT_VERSION "0.0.1")

ADD_DEFINITIONS(-O2 -g --std=gnu99 -Wall -fmax-errors=10)

SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")

ADD_SUBDIRECTORY(myhtml)

# Packing stuff
SET(CPACK_PACKAGE_VENDOR "FMSoft")
SET(CPACK_PACKAGE_NAME ${PROJECT_NAME})
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Examples of Purring Cat 2")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}")
SET(CPACK_SOURCE_GENERATOR "TGZ")
SET(CPACK_SOURCE_IGNORE_FILES
      "/auto/;/cmake/;/.svn/;/.git/;/.bzr/;/CMakeFiles/;/_CPack_Packages/;CMakeCache.txt$;
      ~$;.swp$;.cmake$;
      ${CPACK_SOURCE_IGNORE_FILES}")

INCLUDE(CPack)

=== deprecated/test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

add_subdirectory(rwstream)

=== Source/ExtDVObjs/fs/CMakeLists.txt ===
include(PurCCommon)

set(FS_LIBRARY_TYPE SHARED)

set(FS_PUBLIC_HEADERS
)

set(FS_SOURCES
    file.c
)

set(FS_PRIVATE_INCLUDE_DIRECTORIES
    "${CMAKE_BINARY_DIR}"
    "${GLIB_INCLUDE_DIRS}"
    "${FORWARDING_HEADERS_DIR}"
    "${PURC_DIR}"
    "${PurC_DERIVED_SOURCES_DIR}"
    "${PURC_DIR}/include"
)

set(FS_LIBRARIES
    ${CMAKE_DL_LIBS}
)

link_directories (${CMAKE_BINARY_DIR}/Source/PurC)
list(APPEND FS_LIBRARIES PurC::PurC)

PURC_FRAMEWORK_DECLARE(FS)
PURC_INCLUDE_CONFIG_FILES_IF_EXISTS()

set_target_properties(FS PROPERTIES OUTPUT_NAME "purc-dvobj-FS")
set_target_properties(FS PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")

PURC_WRAP_SOURCELIST(${FS_SOURCES})
PURC_FRAMEWORK(FS)

install(TARGETS FS DESTINATION "${LIB_INSTALL_DIR}/purc-${PURC_API_VERSION}")

if (MSVC)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /SUBSYSTEM:WINDOWS")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /SUBSYSTEM:WINDOWS")
endif ()

=== debian/changelog ===
hvml-purc (0.8.1-1) unstable; urgency=medium

  * initial release

 -- lichenggang <lichenggang@uniontech.com>  Tue, 23 Mar 2021 08:49:57 +0100

=== debian/control ===
Source: hvml-purc
Section: libs
Priority: optional
Maintainer: Vincent Wei <vincent@minigui.org>
Build-Depends: debhelper-compat (= 13), cmake, bison, flex, python3, libglib2.0-dev, linux-libc-dev, libcurl4
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://github.com/HVML/PurC

Package: libhvml-purc-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: PurC is the prime HVML interpreter for C language.
 HVML is a new-style and general-purpose programming language 
 proposed by Vincent Wei, who is the author of the China-first 
 open source project - MiniGUI. 
 This package contains the shared library

Package: hvml-purc-bin
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: PurC is the prime HVML interpreter for C language.
 HVML is a new-style and general-purpose programming language 
 proposed by Vincent Wei, who is the author of the China-first 
 open source project - MiniGUI.
 This package contains the binary files

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_configure:
	cmake -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr -DPORT=Linux .

#override_dh_installdocs:
# Do not install a copyright file
# no /usr/share/docs/* needed!
#dh_installdocs --exclude=debian/copyright
# Do not install changelogs for space conservation
#override_dh_installchangelogs:
